(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)

open Common
open Automata
open SDFA

module Symbolic(Q: QUEUE)(R: Upto.T) = struct
  let equiv a x y =
    let r = R.empty () in
    let todo = Q.singleton ([],x,y) in
    let scan_span = Span.iter2 (Bdd.pairs (Q.push todo)) in
    let rec loop () = 
      match Q.pop todo with
      | None -> None
      | Some (w,x,y) ->
        if R.merge r x y then loop () else (
	Stats.incr "output_tests";
        if a.o x != a.o y then Some (a.o x, a.o y, w) else (
  	scan_span w (a.t x) (a.t y);
  	loop ()))
    in loop ()
end

module SymbolicHK(Q: QUEUE) = struct
  let equiv a x y =
    if x=y then None else
    let todo = Q.singleton ([],x,y) in
    let scan_span = Span.iter2 (Bdd.pairs' (Q.push todo)) in
    let rec loop () = 
      match Q.pop todo with
      | None -> None
      | Some (w,x,y) ->
	Stats.incr "output_tests";
        if a.o x != a.o y then Some (a.o x, a.o y, w) else (
  	scan_span w (a.t x) (a.t y);
  	loop ())
    in loop ()
end
