{
(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)
open Parser 
}

let var = [ 'k'-'z' ]
let prd = [ 'a'-'j' ]
let blank = [ ' ' '\r' '\t' ]

rule token = parse
  | [ ' ' '\r' '\t' '\n' ]+       { token lexbuf }
  | '0'                           { ZER }
  | '1'                           { ONE }
  | var as v                      { VAR v }
  | prd as v                      { PRD v }
  | '+'                           { PLS }
  | '*'                           { STR }
  | '!'                           { NEG }
  | '('                           { LPAR }
  | ')'                           { RPAR }
  | eof                           { EOF }
  | _                             { failwith "lexing error" }
