(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)

let t = Hashtbl.create 10

let count_calls s f = 
  let r = 
    try Hashtbl.find t s
    with Not_found -> let r = ref 0 in Hashtbl.add t s r; r
  in fun x -> incr r; f x

let incr s =
  try incr (Hashtbl.find t s)
  with Not_found -> Hashtbl.add t s (ref 1)

let get s = try !(Hashtbl.find t s) with Not_found -> 0

let print f =
  Format.fprintf f "stats:\n";
  Hashtbl.iter (fun s i -> Format.fprintf f "%s: %i\n" s !i) t

let reset () = Hashtbl.clear t
