(*******************************************************************)
(*  This is part of SymbolicKAT, it is distributed under the       *)
(*  terms of the GNU Lesser General Public License version 3       *)
(*           (see file LICENSE for more details)                   *)
(*                                                                 *)
(*  Copyright 2014: Damien Pous. (CNRS, LIP - ENS Lyon, UMR 5668)  *)
(*******************************************************************)

module type T = sig
  type 'a t
  val empty: unit -> 'a t
  val merge: 'a t -> 'a -> 'a -> bool
  (* return [true] if already merged *)
end

module SET = struct
  type 'a t = ('a*'a,unit) Hashtbl.t
  let empty () = Hashtbl.create 57
  let merge t x y =
    if Hashtbl.mem t (x,y) then true
    else (Hashtbl.add t (x,y) (); false)
end

module DSF = struct
  type 'a t = ('a,'a) Hashtbl.t
  let empty () = Hashtbl.create 57
  let rec find t x =
    match Common.get t x with
      | None -> x
      | Some y -> 
        match Common.get t y with
  	| None -> y
  	| Some z -> Hashtbl.replace t x z; find t z
  let merge t x y =
    let x = find t x in
    let y = find t y in
    if x=y then true
    else (Hashtbl.replace t x y; false)
end
